; 
    include \masm32\include\masm32rt.inc
    .686
    include timers.asm

    qwcmp MACRO arg1, arg2
        fild  arg2
        fild  arg1
        fcomip st(0),st(1)
        fwait
    ENDM
; 
    .data
      VAR1 qword 1
      VAR2 qword 2
    .code
; 
start:
; 
    LOOP_COUNT EQU 10000000
    REPEAT_COUNT EQU 128

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      qwcmp VAR1, VAR2
    counter_end
    print ustr$(eax)
    print " cycles",13,10    

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT      
        MOV EAX,DWORD PTR VAR1        ;use any convenient registers
        SUB EAX,DWORD PTR VAR2        ;subtract the lower QWORD first
        MOV ECX,EAX                   ;store result for testing later
        MOV EAX,DWORD PTR VAR1+DWORD
        SBB EAX,DWORD PTR VAR2+DWORD  ;now the upper QWORD
      ENDM  
    counter_end
    shr   eax, 7
    print ustr$(eax)
    print " cycles",13,10

    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 
end start
 